require 'raptest/asset'

module Raptest
  class Test
    
    attr_accessor :targets, :started_at, :finished_at, :errors, :processed
    
    def initialize(*targets)
      @targets = targets.map { |a|
        ::Raptest::Asset.new(a)
      }
    end

    def duration
      @start_time && @end_time ? ( @end_time - @start_time ) : 0
    end
    
    def run          
      @started_at = Time.now
      @errors     = 0
      @processed  = 0
    
      targets.each do |asset|
        @processed += 1
        
        begin
          asset.test!
        rescue Exception => e
          @errors += 1
          raise e
        end
        
      end

      @finished_at = Time.now
    end

  end
end